import Flutter
import UIKit

public class SwiftAppierFlutterPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "appier_flutter", binaryMessenger: registrar.messenger())
    let instance = SwiftAppierFlutterPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

public func handle(_ call: FlutterMethodCall, result: FlutterResult) {

    let arguments:[String:Any] = call.arguments as! [String:Any]
    print(arguments)
    if "configure" == call.method {

        let appId:String? = arguments["appId"] as? String
        let appGroup:String? = arguments["appGroup"] as? String
        let isDev:Bool? = arguments["isDev"] as? Bool

        let valueAppId:String = appId ?? ""
        let valueAppGroup:String? = appGroup
        let valueIsDev:Bool = isDev ?? false

        print("valueAppId:\(valueAppId)")
        print("valueAppGroup:\(valueAppGroup)")
        print("valueIsDev:\(valueIsDev)")

        QGSdk.getSharedInstance().onStart(valueAppId, withAppGroup: valueAppGroup, setDevProfile: valueIsDev)
        result(nil)
        return
    } else if "logEvent" == call.method {

        let name:String? = arguments["eventName"] as? String
        let parameters:[String:Any]? = arguments["parameters"] as? [String:Any]
        let vts:NSNumber? = arguments["vts"] as? NSNumber
        let vtsCurr:String? = arguments["vtsCurr"] as? String

        let valueName:String = name ?? ""
        let valueParameters:[String:Any] = parameters ?? [:]
        let valueVts:NSNumber? = vts
        let valueVtsCurr:String? = vtsCurr

        print("valueName:\(valueName)")
        print("valueParameters:\(valueParameters)")
        print("valueVts:\(valueVts)")
        print("valueVtsCurr:\(valueVtsCurr)")

        QGSdk.getSharedInstance().logEvent(valueName, withParameters: valueParameters, withValueToSum: valueVts, withValueToSumCurrency: valueVtsCurr)
        result(nil)
    } else {
        result(FlutterMethodNotImplemented)
    }
  }
}
